## castxml 0.1+git20170823

=== CMakeLists.txt ===
#=============================================================================
# Copyright Kitware, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#=============================================================================
cmake_minimum_required(VERSION 2.8.5)
project(CastXML)

include(src/Version.cmake)

include(CTest)

# Build tree locations.
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CastXML_BINARY_DIR}/bin")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CastXML_BINARY_DIR}/lib")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CastXML_BINARY_DIR}/lib")

# Install tree locations.
if(NOT CastXML_INSTALL_RUNTIME_DIR)
  set(CastXML_INSTALL_RUNTIME_DIR bin)
endif()
if(NOT CastXML_INSTALL_DATA_DIR)
  set(CastXML_INSTALL_DATA_DIR share/castxml)
endif()
if(NOT CastXML_INSTALL_DOC_DIR)
  set(CastXML_INSTALL_DOC_DIR share/doc/castxml)
endif()
if(NOT CastXML_INSTALL_MAN_DIR)
  set(CastXML_INSTALL_MAN_DIR man)
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
  if(NOT LLVM_ENABLE_EH)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions")
  endif()
  if(NOT LLVM_ENABLE_RTTI)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti")
  endif()
  if(CYGWIN OR MINGW)
    # Use GNU extensions on Windows as LLVM upstream does.
    set(std_cxx11 "-std=gnu++11")
  else()
    set(std_cxx11 "-std=c++11")
  endif()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${std_cxx11}")
endif()

find_package(LLVM REQUIRED)

if(DEFINED LLVM_BUILD_BINARY_DIR)
  message(FATAL_ERROR
    "LLVM_DIR refers to a LLVM/Clang build directory:\n"
    "  ${LLVM_DIR}\n"
    "CastXML must be built against a LLVM/Clang install tree as "
    "specified in\n"
    "  ${CastXML_SOURCE_DIR}/README.rst")
endif()

set(found_clang 0)
set(tried_clang)
foreach(inc ${LLVM_INCLUDE_DIRS})
  if(EXISTS "${inc}/clang/AST/ASTConsumer.h")
    set(found_clang 1)
    break()
  else()
    set(tried_clang "  ${inc}\n")
  endif()
endforeach()
if(NOT found_clang)
  message(FATAL_ERROR
    "LLVM_DIR refers to a LLVM installation:\n"
    "  ${LLVM_DIR}\n"
    "that does not have `clang/` headers in any include directory:\n"
    "${tried_clang}"
    )
endif()

add_definitions(${LLVM_DEFINITIONS})
include_directories(${LLVM_INCLUDE_DIRS})
link_directories(${LLVM_LIBRARY_DIRS})
if(NOT DEFINED LLVM_VERSION_PATCH)
  set(LLVM_VERSION_PATCH 0)
endif()

set(CLANG_RESOURCE_DIR "" CACHE PATH "Clang resource directory")
if(NOT CLANG_RESOURCE_DIR)
  set(v ${LLVM_VERSION_MAJOR}.${LLVM_VERSION_MINOR}.${LLVM_VERSION_PATCH})
  set(tried "")
  foreach(d ${LLVM_LIBRARY_DIRS})
    if(IS_DIRECTORY "${d}/clang/${v}/include")
      set(CLANG_RESOURCE_DIR ${d}/clang/${v})
      break()
    endif()
    set(tried "${tried}\n  ${d}/clang/${v}")
  endforeach()
  if(NOT CLANG_RESOURCE_DIR)
    if(tried)
      set(tried "  Tried:${tried}")
    endif()
    message(FATAL_ERROR "Could not find CLANG_RESOURCE_DIR.${tried}"
      "\n"
      "Please set CLANG_RESOURCE_DIR to the Clang SDK directory containing "
      "\"include/stddef.h\", typically of the form \"<prefix>/lib/clang/${v}\"."
      )
  endif()
  unset(tried)
endif()

install(DIRECTORY ${CLANG_RESOURCE_DIR}/include
  DESTINATION "${CastXML_INSTALL_DATA_DIR}/clang"
  )

add_subdirectory(src)

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

add_subdirectory(doc)

install(DIRECTORY share/castxml/ DESTINATION "${CastXML_INSTALL_DATA_DIR}")

install(FILES
  "LICENSE"
  "NOTICE"
  DESTINATION "${CastXML_INSTALL_DOC_DIR}"
  )

=== doc/CMakeLists.txt ===
#=============================================================================
# Copyright Kitware, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#=============================================================================
project(CastXMLDoc NONE)

option(SPHINX_MAN "Build man pages with Sphinx" OFF)
option(SPHINX_HTML "Build html pages with Sphinx" OFF)
find_program(SPHINX_EXECUTABLE
  NAMES sphinx-build
  DOC "Sphinx Documentation Builder (sphinx-doc.org)"
  )

if(NOT SPHINX_MAN AND NOT SPHINX_HTML)
  return()
elseif(NOT SPHINX_EXECUTABLE)
  message(FATAL_ERROR "SPHINX_EXECUTABLE (sphinx-build) is not found!")
endif()

set(copyright_line_regex "^Copyright (2013-20[0-9][0-9] Kitware.*)")
file(STRINGS "${CastXML_SOURCE_DIR}/NOTICE" copyright_line
  LIMIT_COUNT 1 REGEX "${copyright_line_regex}")
if(copyright_line MATCHES "${copyright_line_regex}")
  set(conf_copyright "${CMAKE_MATCH_1}")
else()
  set(conf_copyright "Kitware, Inc.")
endif()

set(conf_docs "${CastXML_SOURCE_DIR}/doc")
set(conf_path "${CMAKE_CURRENT_SOURCE_DIR}")
set(conf_version "${CastXML_VERSION}")
set(conf_release "${CastXML_VERSION}")
configure_file(conf.py.in conf.py @ONLY)

set(doc_formats "")
if(SPHINX_HTML)
  list(APPEND doc_formats html)
endif()
if(SPHINX_MAN)
  list(APPEND doc_formats man)
endif()

set(doc_format_outputs "")
set(doc_format_last "")
foreach(format ${doc_formats})
  set(doc_format_output "doc_format_${format}")
  set(doc_format_log "build-${format}.log")
  add_custom_command(
    OUTPUT ${doc_format_output}
    COMMAND ${SPHINX_EXECUTABLE}
            -c ${CMAKE_CURRENT_BINARY_DIR}
            -d ${CMAKE_CURRENT_BINARY_DIR}/doctrees
            -b ${format}
            ${CastXML_SOURCE_DIR}/doc
            ${CMAKE_CURRENT_BINARY_DIR}/${format}
            > ${doc_format_log} # log stdout, pass stderr
    DEPENDS ${doc_format_last}
    COMMENT "sphinx-build ${format}: see doc/${doc_format_log}"
    VERBATIM
    )
  set_property(SOURCE ${doc_format_output} PROPERTY SYMBOLIC 1)
  list(APPEND doc_format_outputs ${doc_format_output})
  set(doc_format_last ${doc_format_output})
endforeach()

add_custom_target(documentation ALL DEPENDS ${doc_format_outputs})

if(SPHINX_MAN)
  file(GLOB man_rst RELATIVE ${CastXML_SOURCE_DIR}/doc/manual
    ${CastXML_SOURCE_DIR}/doc/manual/*.[1-9].rst)
  foreach(m ${man_rst})
    if("x${m}" MATCHES "^x(.+)\\.([1-9])\\.rst$")
      set(name "${CMAKE_MATCH_1}")
      set(sec "${CMAKE_MATCH_2}")
      install(FILES ${CMAKE_CURRENT_BINARY_DIR}/man/${name}.${sec}
              DESTINATION ${CastXML_INSTALL_MAN_DIR}/man${sec})
    endif()
  endforeach()
endif()

if(SPHINX_HTML)
  install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
          DESTINATION ${CastXML_INSTALL_DOC_DIR}
          PATTERN .buildinfo EXCLUDE
          PATTERN objects.inv EXCLUDE
          )
endif()

=== src/CMakeLists.txt ===
#=============================================================================
# Copyright Kitware, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#=============================================================================

# Tell executables in the build tree where to find the source tree.
configure_file(
  "SourceDir.txt.in"
  "${CastXML_BINARY_DIR}/CMakeFiles/castxmlSourceDir.txt" @ONLY
  )
# Tell executables in the build tree where to find Clang resources.
configure_file(
  "ClangResourceDir.txt.in"
  "${CastXML_BINARY_DIR}/CMakeFiles/castxmlClangResourceDir.txt" @ONLY
  )
# Configure version number for C++ code.
configure_file(
  "Version.h.in"
  "${CastXML_BINARY_DIR}/src/Version.h" @ONLY
  )

include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(clang_libs
  clangFrontend
  clangDriver
  clangSerialization
  clangParse
  clangSema
  clangAnalysis
  clangEdit
  clangAST
  clangLex
  clangBasic
  )

llvm_map_components_to_libnames(llvm_libs
  native
  option
  bitreader
  support
  ${LLVM_TARGETS_TO_BUILD}
  )
if(WIN32)
  list(APPEND llvm_libs version.lib)
endif()

add_executable(castxml
  castxml.cxx

  Detect.cxx Detect.h
  Options.h
  Output.cxx Output.h
  RunClang.cxx RunClang.h
  Utils.cxx Utils.h
  )
target_link_libraries(castxml
  ${clang_libs}
  ${llvm_libs}
  )
set_property(SOURCE Utils.cxx APPEND PROPERTY COMPILE_DEFINITIONS
  "CASTXML_INSTALL_DATA_DIR=\"${CastXML_INSTALL_DATA_DIR}\"")
install(TARGETS castxml DESTINATION ${CastXML_INSTALL_RUNTIME_DIR})

=== debian/changelog ===
castxml (0.1+git20170823-1) unstable; urgency=medium

  * New upstream version, Closes: #871573
  * d/control: Update my e-mail address
  * d/control: Set standards version 4.1.0, no changes needed
  * d/control, d/rules: Switch to clang-4.0

 -- Gert Wollny <gewo@debian.org>  Thu, 24 Aug 2017 10:25:34 +0000

=== debian/control ===
Source: castxml
Maintainer: Steve M. Robbins <smr@debian.org>
Uploaders: Gert Wollny <gewo@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper (>= 10),
               cmake,
               help2man,
               libclang-4.0-dev,
               llvm-4.0-dev,
               libedit-dev,
               zlib1g-dev
Standards-Version: 4.0.0
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/castxml.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/castxml.git
Homepage: https://github.com/CastXML/CastXML

Package: castxml
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: C-family abstract syntax tree XML output tool
 Parse C-family source files and optionally write a subset of the
 Abstract Syntax Tree (AST) to a representation in XML.
 This is the successor to gccxml.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CMAKE_FLAGS = -DCastXML_INSTALL_DOC_DIR:STRING=/usr/share/doc/castxml \
              -DLLVM_DIR=/usr/lib/llvm-4.0/cmake

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_installman:
	help2man -n "Create an XML representation of C++ declarations" --no-info debian/castxml/usr/bin/castxml  > castxml.1
	dh_installman castxml.1

## castxml 0.1+git20180702

=== CMakeLists.txt ===
--- 
+++ 
@@ -33,7 +33,11 @@
   set(CastXML_INSTALL_DATA_DIR share/castxml)
 endif()
 if(NOT CastXML_INSTALL_DOC_DIR)
-  set(CastXML_INSTALL_DOC_DIR share/doc/castxml)
+  if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
+    set(CastXML_INSTALL_DOC_DIR share/doc/castxml)
+  else()
+    set(CastXML_INSTALL_DOC_DIR doc/castxml)
+  endif()
 endif()
 if(NOT CastXML_INSTALL_MAN_DIR)
   set(CastXML_INSTALL_MAN_DIR man)
@@ -55,12 +59,51 @@
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${std_cxx11}")
 endif()
 
-find_package(LLVM REQUIRED)
+macro(hint_clang_from_llvm)
+  if(LLVM_DIR AND NOT Clang_DIR)
+    if(LLVM_DIR MATCHES "share/llvm/cmake$")
+      # LLVM/Clang 3.8 installs in <prefix>/share/{llvm,clang}/cmake
+      get_filename_component(Clang_DIR "${LLVM_DIR}/../../clang/cmake" ABSOLUTE)
+    else()
+      # LLVM/Clang 3.9+ installs in <prefix>/lib/cmake/{llvm,clang}
+      get_filename_component(Clang_DIR "${LLVM_DIR}/../clang" ABSOLUTE)
+    endif()
+  endif()
+endmacro()
+
+macro(hint_llvm_from_clang)
+  if(Clang_DIR AND NOT LLVM_DIR)
+    if(Clang_DIR MATCHES "share/clang/cmake$")
+      # LLVM/Clang 3.8 installs in <prefix>/share/{llvm,clang}/cmake
+      get_filename_component(LLVM_DIR "${Clang_DIR}/../../llvm/cmake" ABSOLUTE)
+    else()
+      # LLVM/Clang 3.9+ installs in <prefix>/lib/cmake/{llvm,clang}
+      get_filename_component(LLVM_DIR "${Clang_DIR}/../llvm" ABSOLUTE)
+    endif()
+  endif()
+endmacro()
+
+# Build scripts may set either LLVM_DIR or Clang_DIR.
+hint_llvm_from_clang()
+hint_clang_from_llvm()
+
+# Clang 3.8+ installs its own CMake package.  Try it first.
+find_package(Clang QUIET)
+
+# If Clang did not find LLVM for us, give our search below a hint.
+hint_llvm_from_clang()
+
+# Clang 3.9+ automatically searches for LLVM.  For older versions we
+# may need to search for LLVM directly.  Either way we require LLVM.
+if(NOT LLVM_FOUND)
+  find_package(LLVM REQUIRED)
+endif()
 
 if(DEFINED LLVM_BUILD_BINARY_DIR)
   message(FATAL_ERROR
-    "LLVM_DIR refers to a LLVM/Clang build directory:\n"
-    "  ${LLVM_DIR}\n"
+    "Clang_DIR or LLVM_DIR refers to a LLVM/Clang build directory:\n"
+    "  Clang_DIR=${Clang_DIR}\n"
+    "  LLVM_DIR=${LLVM_DIR}\n"
     "CastXML must be built against a LLVM/Clang install tree as "
     "specified in\n"
     "  ${CastXML_SOURCE_DIR}/README.rst")
@@ -68,7 +111,7 @@
 
 set(found_clang 0)
 set(tried_clang)
-foreach(inc ${LLVM_INCLUDE_DIRS})
+foreach(inc ${CLANG_INCLUDE_DIRS} ${LLVM_INCLUDE_DIRS})
   if(EXISTS "${inc}/clang/AST/ASTConsumer.h")
     set(found_clang 1)
     break()
@@ -78,14 +121,16 @@
 endforeach()
 if(NOT found_clang)
   message(FATAL_ERROR
-    "LLVM_DIR refers to a LLVM installation:\n"
-    "  ${LLVM_DIR}\n"
+    "Clang_DIR or LLVM_DIR refers to a LLVM/Clang installation:\n"
+    "  Clang_DIR=${Clang_DIR}\n"
+    "  LLVM_DIR=${LLVM_DIR}\n"
     "that does not have `clang/` headers in any include directory:\n"
     "${tried_clang}"
     )
 endif()
 
 add_definitions(${LLVM_DEFINITIONS})
+include_directories(${CLANG_INCLUDE_DIRS})
 include_directories(${LLVM_INCLUDE_DIRS})
 link_directories(${LLVM_LIBRARY_DIRS})
 if(NOT DEFINED LLVM_VERSION_PATCH)
@@ -96,7 +141,19 @@
 if(NOT CLANG_RESOURCE_DIR)
   set(v ${LLVM_VERSION_MAJOR}.${LLVM_VERSION_MINOR}.${LLVM_VERSION_PATCH})
   set(tried "")
+  set(dirs "")
   foreach(d ${LLVM_LIBRARY_DIRS})
+    # Clang resources are typically inside LLVM's library directory.
+    list(APPEND dirs ${d})
+    # Some distros use a layout of the form
+    #     <prefix>/lib/llvm/<major-version>/lib
+    #     <prefix>/lib/clang/<full-version>/include
+    if("${d}" MATCHES "^(.*)/llvm/.*$")
+      list(APPEND dirs "${CMAKE_MATCH_1}")
+    endif()
+  endforeach()
+  # Look in each candidate directory for Clang resources.
+  foreach(d ${dirs})
     if(IS_DIRECTORY "${d}/clang/${v}/include")
       set(CLANG_RESOURCE_DIR ${d}/clang/${v})
       break()

=== test/CMakeLists.txt ===
#=============================================================================
# Copyright Kitware, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#=============================================================================

# Keep test binaries away from main binaries.
unset(CMAKE_RUNTIME_OUTPUT_DIRECTORY)
unset(CMAKE_LIBRARY_OUTPUT_DIRECTORY)
unset(CMAKE_ARCHIVE_OUTPUT_DIRECTORY)

find_package(LibXml2 QUIET)

macro(castxml_test_cmd test)
  set(command $<TARGET_FILE:castxml> ${ARGN})
  set(_castxml_expect ${castxml_test_cmd_expect} cmd.${test})
  add_test(
    NAME cmd.${test}
    COMMAND ${CMAKE_COMMAND}
    "-Dcommand:STRING=${command}"
    "-Dexpect=${_castxml_expect}"
    ${castxml_test_cmd_extra_arguments}
    -P ${CMAKE_CURRENT_SOURCE_DIR}/run.cmake
    )
endmacro()

macro(castxml_test_output_common prefix ext std test)
  if(DEFINED castxml_test_output_custom_start)
    set(_castxml_start ${castxml_test_output_custom_start})
  else()
    set(_castxml_start --castxml-start start)
  endif()
  if(castxml_test_output_custom_input)
    set(_castxml_input ${castxml_test_output_custom_input})
  else()
    set(_castxml_input ${test})
  endif()
  set(_castxml_expect ${prefix}.${std}.${test})
  if("${std}" MATCHES "^gnu(.*)$")
    list(APPEND _castxml_expect ${prefix}.c${CMAKE_MATCH_1}.${test})
  endif()
  if("${std}" MATCHES "^(c|gnu)[^+]")
    list(APPEND _castxml_expect ${prefix}.c.${test})
  endif()
  list(APPEND _castxml_expect ${prefix}.any.${test})

  if ("${prefix}" MATCHES "^gccxml(.*)$")
    set(flag --castxml-gccxml)
  elseif ("${prefix}" MATCHES "^castxml1(.*)$")
    set(flag --castxml-output=1)
  endif()

  set(std_flag -std=${std})
  if(LLVM_VERSION_MAJOR VERSION_LESS 5)
    if("${std_flag}" MATCHES "^(.*)17$")
      set(std_flag "${CMAKE_MATCH_1}1z")
    endif()
  endif()

  set(command $<TARGET_FILE:castxml>
    ${flag}
    ${_castxml_start}
    ${std_flag}
    ${CMAKE_CURRENT_LIST_DIR}/input/${_castxml_input}.${ext}
    -o ${prefix}.${std}.${test}.xml
    ${castxml_test_output_extra_arguments}
    )
  add_test(
    NAME ${prefix}.${std}.${test}
    COMMAND ${CMAKE_COMMAND}
    "-Dcommand:STRING=${command}"
    "-Dexpect=${_castxml_expect}"
    "-Dxml=${prefix}.${std}.${test}.xml"
    "-Dxmllint=${LIBXML2_XMLLINT_EXECUTABLE}"
    -P ${CMAKE_CURRENT_SOURCE_DIR}/run.cmake
    )
endmacro()

macro(castxml_test_output_c89 test)
  castxml_test_output_common(gccxml c c89 ${test})
  castxml_test_output_common(castxml1 c c89 ${test})
endmacro()

macro(castxml_test_output_c99 test)
  castxml_test_output_common(gccxml c c99 ${test})
  castxml_test_output_common(castxml1 c c99 ${test})
endmacro()

macro(castxml_test_output_c11 test)
  castxml_test_output_common(gccxml c c11 ${test})
  castxml_test_output_common(castxml1 c c11 ${test})
endmacro()

macro(castxml_test_output_gnu89 test)
  castxml_test_output_common(gccxml c gnu89 ${test})
  castxml_test_output_common(castxml1 c gnu89 ${test})
endmacro()

macro(castxml_test_output_gnu99 test)
  castxml_test_output_common(gccxml c gnu99 ${test})
  castxml_test_output_common(castxml1 c gnu99 ${test})
endmacro()

macro(castxml_test_output_gnu11 test)
  castxml_test_output_common(gccxml c gnu11 ${test})
  castxml_test_output_common(castxml1 c gnu11 ${test})
endmacro()

macro(castxml_test_output_cxx98 test)
  castxml_test_output_common(gccxml cxx c++98 ${test})
  castxml_test_output_common(castxml1 cxx c++98 ${test})
endmacro()

macro(castxml_test_output_gnuxx98 test)
  castxml_test_output_common(gccxml cxx gnu++98 ${test})
  castxml_test_output_common(castxml1 cxx gnu++98 ${test})
endmacro()

macro(castxml_test_output_cxx11 test)
  castxml_test_output_common(gccxml cxx c++11 ${test})
  castxml_test_output_common(castxml1 cxx c++11 ${test})
endmacro()

macro(castxml_test_output_gnuxx11 test)
  castxml_test_output_common(gccxml cxx gnu++11 ${test})
  castxml_test_output_common(castxml1 cxx gnu++11 ${test})
endmacro()

macro(castxml_test_output_cxx14 test)
  castxml_test_output_common(gccxml cxx c++14 ${test})
  castxml_test_output_common(castxml1 cxx c++14 ${test})
endmacro()

macro(castxml_test_output_gnuxx14 test)
  castxml_test_output_common(gccxml cxx gnu++14 ${test})
  castxml_test_output_common(castxml1 cxx gnu++14 ${test})
endmacro()

macro(castxml_test_output_cxx17 test)
  castxml_test_output_common(gccxml cxx c++17 ${test})
  castxml_test_output_common(castxml1 cxx c++17 ${test})
endmacro()

macro(castxml_test_output_gnuxx17 test)
  castxml_test_output_common(gccxml cxx gnu++17 ${test})
  castxml_test_output_common(castxml1 cxx gnu++17 ${test})
endmacro()

macro(castxml_test_output_broken_cxx98 test)
  castxml_test_output_common(gccxml.broken cxx c++98 ${test})
  castxml_test_output_common(castxml1.broken cxx c++98 ${test})
endmacro()

macro(castxml_test_output_broken_gnuxx98 test)
  castxml_test_output_common(gccxml.broken cxx gnu++98 ${test})
  castxml_test_output_common(castxml1.broken cxx gnu++98 ${test})
endmacro()

macro(castxml_test_output_broken_cxx11 test)
  castxml_test_output_common(gccxml.broken cxx c++11 ${test})
  castxml_test_output_common(castxml1.broken cxx c++11 ${test})
endmacro()

macro(castxml_test_output_broken_gnuxx11 test)
  castxml_test_output_common(gccxml.broken cxx gnu++11 ${test})
  castxml_test_output_common(castxml1.broken cxx gnu++11 ${test})
endmacro()

macro(castxml_test_output_broken_cxx14 test)
  castxml_test_output_common(gccxml.broken cxx c++14 ${test})
  castxml_test_output_common(castxml1.broken cxx c++14 ${test})
endmacro()

macro(castxml_test_output_broken_gnuxx14 test)
  castxml_test_output_common(gccxml.broken cxx gnu++14 ${test})
  castxml_test_output_common(castxml1.broken cxx gnu++14 ${test})
endmacro()

macro(castxml_test_output_broken_cxx17 test)
  castxml_test_output_common(gccxml.broken cxx c++17 ${test})
  castxml_test_output_common(castxml1.broken cxx c++17 ${test})
endmacro()

macro(castxml_test_output_broken_gnuxx17 test)
  castxml_test_output_common(gccxml.broken cxx gnu++17 ${test})
  castxml_test_output_common(castxml1.broken cxx gnu++17 ${test})
endmacro()

macro(castxml_test_output_c test)
  castxml_test_output_c89(${test})
  castxml_test_output_gnu89(${test})
  castxml_test_output_c99(${test})
  castxml_test_output_gnu99(${test})
  castxml_test_output_c11(${test})
  castxml_test_output_gnu11(${test})
endmacro()

macro(castxml_test_output test)
  castxml_test_output_cxx98(${test})
  castxml_test_output_gnuxx98(${test})
  castxml_test_output_cxx11(${test})
  castxml_test_output_gnuxx11(${test})
  castxml_test_output_cxx14(${test})
  castxml_test_output_gnuxx14(${test})
  castxml_test_output_cxx17(${test})
  castxml_test_output_gnuxx17(${test})
endmacro()

macro(castxml_test_output_11 test)
  castxml_test_output_cxx11(${test})
  castxml_test_output_gnuxx11(${test})
  castxml_test_output_cxx14(${test})
  castxml_test_output_gnuxx14(${test})
  castxml_test_output_cxx17(${test})
  castxml_test_output_gnuxx17(${test})
endmacro()

macro(castxml_test_output_14 test)
  castxml_test_output_cxx14(${test})
  castxml_test_output_gnuxx14(${test})
  castxml_test_output_cxx17(${test})
  castxml_test_output_gnuxx17(${test})
endmacro()

macro(castxml_test_output_14below test)
  castxml_test_output_cxx98(${test})
  castxml_test_output_gnuxx98(${test})
  castxml_test_output_cxx11(${test})
  castxml_test_output_gnuxx11(${test})
  castxml_test_output_cxx14(${test})
  castxml_test_output_gnuxx14(${test})
endmacro()

macro(castxml_test_output_broken test)
  castxml_test_output_broken_cxx98(${test})
  castxml_test_output_broken_gnuxx98(${test})
  castxml_test_output_broken_cxx11(${test})
  castxml_test_output_broken_gnuxx11(${test})
  castxml_test_output_broken_cxx14(${test})
  castxml_test_output_broken_gnuxx14(${test})
  castxml_test_output_broken_cxx17(${test})
  castxml_test_output_broken_gnuxx17(${test})
endmacro()

set(input ${CMAKE_CURRENT_LIST_DIR}/input)
set(empty_c ${input}/empty.c)
set(empty_cxx ${input}/empty.cxx)
set(empty_m ${input}/empty.m)
set(empty_mm ${input}/empty.mm)

castxml_test_cmd(help1 -help)
castxml_test_cmd(help2 --help)
castxml_test_cmd(no-arguments)
castxml_test_cmd(version --version)

castxml_test_cmd(cc-missing --castxml-cc-gnu)
castxml_test_cmd(cc-option --castxml-cc-gnu -)
castxml_test_cmd(cc-paren-castxml --castxml-cc-gnu "(" --castxml-cc-msvc ")")
castxml_test_cmd(cc-paren-nested --castxml-cc-gnu "(" "(" ")" ")")
castxml_test_cmd(cc-paren-unbalanced --castxml-cc-gnu "(")
castxml_test_cmd(cc-twice --castxml-cc-msvc cl --castxml-cc-gnu gcc)
castxml_test_cmd(cc-unknown --castxml-cc-unknown cc)

castxml_test_cmd(gccxml-and-E --castxml-gccxml -E)
castxml_test_cmd(castxml-and-E --castxml-output=1 -E)

castxml_test_cmd(gccxml-twice --castxml-gccxml --castxml-gccxml)
castxml_test_cmd(castxml-twice --castxml-output=1 --castxml-output=1)

castxml_test_cmd(castxml-mix1 --castxml-gccxml --castxml-output=1)
castxml_test_cmd(castxml-mix2 --castxml-output=1 --castxml-gccxml)

castxml_test_cmd(castxml-wrong-epic-version --castxml-output=0)

castxml_test_cmd(gccxml-and-c99 --castxml-gccxml -std=c99 ${empty_c})
castxml_test_cmd(castxml-and-c99 --castxml-output=1 -std=c99 ${empty_c})

castxml_test_cmd(gccxml-and-c11 --castxml-gccxml -std=c11 ${empty_c})
castxml_test_cmd(castxml-and-c11 --castxml-output=1 -std=c11 ${empty_c})

castxml_test_cmd(gccxml-and-c++11 --castxml-gccxml -std=c++11 ${empty_cxx})
castxml_test_cmd(castxml-and-c++11 --castxml-output=1 -std=c++11 ${empty_cxx})

castxml_test_cmd(gccxml-and-c++14 --castxml-gccxml -std=c++14 ${empty_cxx})
castxml_test_cmd(castxml-and-c++14 --castxml-output=1 -std=c++14 ${empty_cxx})

if(LLVM_VERSION_MAJOR VERSION_LESS 5)
  castxml_test_cmd(gccxml-and-c++17 --castxml-gccxml -std=c++1z ${empty_cxx})
  castxml_test_cmd(castxml-and-c++17 --castxml-output=1 -std=c++1z ${empty_cxx})
else()
  castxml_test_cmd(gccxml-and-c++17 --castxml-gccxml -std=c++17 ${empty_cxx})
  castxml_test_cmd(castxml-and-c++17 --castxml-output=1 -std=c++17 ${empty_cxx})
endif()

castxml_test_cmd(gccxml-and-objc1 --castxml-gccxml ${empty_m})
castxml_test_cmd(castxml-and-objc1 --castxml-output=1 ${empty_m})

castxml_test_cmd(gccxml-and-objc2 --castxml-gccxml ${empty_mm})
castxml_test_cmd(castxml-and-objc2 --castxml-output=1 ${empty_mm})

castxml_test_cmd(gccxml-empty-c++98 --castxml-gccxml -std=c++98 ${empty_cxx})
castxml_test_cmd(castxml-empty-c++98 --castxml-output=1 -std=c++98 ${empty_cxx})

castxml_test_cmd(gccxml-empty-c++98-E --castxml-gccxml -std=c++98 ${empty_cxx} -E)
castxml_test_cmd(castxml-empty-c++98-E --castxml-output=1 -std=c++98 ${empty_cxx} -E)

castxml_test_cmd(gccxml-empty-c++98-c --castxml-gccxml -std=c++98 ${empty_cxx} -c)
castxml_test_cmd(castxml-empty-c++98-c --castxml-output=1 -std=c++98 ${empty_cxx} -c)

castxml_test_cmd(std-c++98-src-c -std=c++98 ${empty_c})
castxml_test_cmd(std-c89-src-cxx -std=c89 ${empty_cxx})
castxml_test_cmd(input-missing ${input}/does-not-exist.c)
castxml_test_cmd(o-missing -o)
castxml_test_cmd(start-missing --castxml-start)
castxml_test_cmd(rsp-empty @${input}/empty.rsp)
castxml_test_cmd(rsp-missing @${input}/does-not-exist.rsp)
castxml_test_cmd(rsp-o-missing @${input}/o-missing.rsp)

# Test predefined macros when not using --castxml-cc-<id>.
math(EXPR __castxml__ "1000000*${CastXML_VERSION_MAJOR} + 1000*${CastXML_VERSION_MINOR} + ${CastXML_VERSION_PATCH}")
configure_file(expect/cmd.predefined-macros.stdout.txt.in
               expect/cmd.predefined-macros.stdout.txt @ONLY)

=== debian/changelog ===
castxml (0.1+git20180702-3) unstable; urgency=medium

  * d/rules: Add -latomic to libs on armel, clang requires it

 -- Gert Wollny <gewo@debian.org>  Sat, 01 Dec 2018 19:26:16 +0100

castxml (0.1+git20180702-2) unstable; urgency=medium

  * Update changelog for upload [ci skip]
  * d/control: cme fix dpkg   
     -  add/correct VCS urls   
     - update standards version to 4.1.5 (no changes neede)
  * d/p:0004: add patch series for llvm7 support, Closes: #912561
  * d/p/0002: Update patch

 -- Gert Wollny <gewo@debian.org>  Sat, 01 Dec 2018 16:38:12 +0100

castxml (0.1+git20180702-1) unstable; urgency=medium

  * New upstream version 0.1+git20180702 Closes: #902811
  * d/control: Update standards to 4.1.4 (no changes)
  * d/copyright: Update url to use https
  * d/p/0002: Add description
  * d/p/0003: Fix linking issue with llvm >= 6.0
  * Add CI file
  * d/p: housecleaning

 -- Gert Wollny <gewo@debian.org>  Sun, 01 Jul 2018 17:58:30 +0200

castxml (0.1+git20170823-2) unstable; urgency=medium

  * d/control: Build-dep on llvm default version, Closes: #893405

 -- Gert Wollny <gewo@debian.org>  Mon, 19 Mar 2018 19:49:37 +0100

=== debian/control ===
--- 
+++ 
@@ -6,14 +6,14 @@
 Build-Depends: debhelper (>= 10),
                cmake,
                help2man,
-               libclang-4.0-dev,
-               llvm-4.0-dev,
+               libclang-dev,
+               llvm-dev,
                libedit-dev,
                zlib1g-dev
-Standards-Version: 4.0.0
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/castxml.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/castxml.git
+Standards-Version: 4.1.5
 Homepage: https://github.com/CastXML/CastXML
+Vcs-Browser:https://salsa.debian.org/med-team/castxml.git
+Vcs-Git: https://salsa.debian.org/med-team/castxml.git
 
 Package: castxml
 Architecture: any

## castxml 0.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -33,11 +33,7 @@
   set(CastXML_INSTALL_DATA_DIR share/castxml)
 endif()
 if(NOT CastXML_INSTALL_DOC_DIR)
-  if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
-    set(CastXML_INSTALL_DOC_DIR share/doc/castxml)
-  else()
-    set(CastXML_INSTALL_DOC_DIR doc/castxml)
-  endif()
+  set(CastXML_INSTALL_DOC_DIR share/doc/castxml)
 endif()
 if(NOT CastXML_INSTALL_MAN_DIR)
   set(CastXML_INSTALL_MAN_DIR man)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -45,16 +45,13 @@
   clangBasic
   )
 
-llvm_map_components_to_libnames(llvm_libs
+set(llvm_libs
   native
   option
   bitreader
   support
   ${LLVM_TARGETS_TO_BUILD}
   )
-if(WIN32)
-  list(APPEND llvm_libs version.lib)
-endif()
 
 add_executable(castxml
   castxml.cxx
@@ -65,10 +62,12 @@
   RunClang.cxx RunClang.h
   Utils.cxx Utils.h
   )
-target_link_libraries(castxml
-  ${clang_libs}
-  ${llvm_libs}
-  )
+if(LLVM_LINK_LLVM_DYLIB)
+  set(USE_SHARED USE_SHARED)
+endif()
+llvm_config(castxml ${USE_SHARED} ${llvm_libs})
+target_link_libraries(castxml PRIVATE ${clang_libs})
+
 set_property(SOURCE Utils.cxx APPEND PROPERTY COMPILE_DEFINITIONS
   "CASTXML_INSTALL_DATA_DIR=\"${CastXML_INSTALL_DATA_DIR}\"")
 install(TARGETS castxml DESTINATION ${CastXML_INSTALL_RUNTIME_DIR})

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -327,6 +327,6 @@
 castxml_test_cmd(rsp-o-missing @${input}/o-missing.rsp)
 
 # Test predefined macros when not using --castxml-cc-<id>.
-math(EXPR __castxml__ "1000000*${CastXML_VERSION_MAJOR} + 1000*${CastXML_VERSION_MINOR} + ${CastXML_VERSION_PATCH}")
 configure_file(expect/cmd.predefined-macros.stdout.txt.in
                expect/cmd.predefined-macros.stdout.txt @ONLY)
+set(castxml_test_cmd_expect ${CMAKE_CURRENT_BINARY_DIR}/expect/cmd.predefined-macros)

=== debian/changelog ===
castxml (0.2.0-4build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:13:05 +0100

castxml (0.2.0-4) unstable; urgency=medium

  [ Gert Wollny ]
  * d/control: Use llvm-9-dev and also use libclang-9-dev to 
    fix problems with g++-9 
  * d/p/0003: Add patch to fix expected output with llvm-9

 -- Gert Wollny <gewo@debian.org>  Thu, 14 Nov 2019 07:59:52 +0100

castxml (0.2.0-3) unstable; urgency=medium

  [ Steven Robbins ]
  * Fix mipsel build by linking with libatomic.

 -- Steve M. Robbins <smr@debian.org>  Sat, 19 Oct 2019 14:37:05 -0500

castxml (0.2.0-2) unstable; urgency=medium

  * upload to unstable

 -- Steve M. Robbins <smr@debian.org>  Tue, 15 Oct 2019 23:34:11 -0500

castxml (0.2.0-1) experimental; urgency=medium

  * s/watch Add watch file
  * New upstream version 0.2.0 Closes: #927891
  * d/p/* Update patches

 -- Gert Wollny <gewo@debian.org>  Sat, 27 Apr 2019 13:07:24 +0200

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
 Build-Depends: debhelper (>= 10),
                cmake,
                help2man,
-               libclang-dev,
-               llvm-dev,
+               libclang-9-dev,
+               llvm-9-dev,
                libedit-dev,
                zlib1g-dev
 Standards-Version: 4.1.5

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,12 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
+# clang pulls in atomics that require an extra library on armel 
+ifeq ($(DEB_HOST_ARCH),armel)
+export DEB_LDFLAGS_MAINT_APPEND=-latomic
+endif 
+
 
 CMAKE_FLAGS = -DCastXML_INSTALL_DOC_DIR:STRING=/usr/share/doc/castxml \
               -DLLVM_DIR=/usr/lib/llvm-4.0/cmake

=== debian/watch ===
version=3

# Uncomment to find new files on Github
#  - when using releases:
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/castxml-$1\.tar\.gz/  \
https://github.com/CastXML/CastXML/releases .*/archive/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## castxml 0.3.3

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 # you may not use this file except in compliance with the License.
 # You may obtain a copy of the License at
 #
-#     http://www.apache.org/licenses/LICENSE-2.0
+#     https://www.apache.org/licenses/LICENSE-2.0
 #
 # Unless required by applicable law or agreed to in writing, software
 # distributed under the License is distributed on an "AS IS" BASIS,

=== debian/changelog ===
castxml (0.3.3-3) unstable; urgency=medium

  * d/p/0004: Disable failing MSVC test

 -- Gert Wollny <gewo@debian.org>  Sun, 26 Apr 2020 16:59:36 +0200

castxml (0.3.3-2) unstable; urgency=medium

  * d/p/0003: re-add libatomic patch

 -- Gert Wollny <gewo@debian.org>  Sun, 26 Apr 2020 16:03:26 +0200

castxml (0.3.3-1) unstable; urgency=medium

  * New upstream version 0.3.3
  * d/p: Update patches

 -- Gert Wollny <gewo@debian.org>  Sun, 26 Apr 2020 14:08:18 +0200

## castxml 0.3.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 # you may not use this file except in compliance with the License.
 # You may obtain a copy of the License at
 #
-#     http://www.apache.org/licenses/LICENSE-2.0
+#     https://www.apache.org/licenses/LICENSE-2.0
 #
 # Unless required by applicable law or agreed to in writing, software
 # distributed under the License is distributed on an "AS IS" BASIS,
@@ -13,7 +13,7 @@
 # See the License for the specific language governing permissions and
 # limitations under the License.
 #=============================================================================
-cmake_minimum_required(VERSION 2.8.5)
+cmake_minimum_required(VERSION 3.3)
 project(CastXML)
 
 include(src/Version.cmake)
@@ -37,22 +37,6 @@
 endif()
 if(NOT CastXML_INSTALL_MAN_DIR)
   set(CastXML_INSTALL_MAN_DIR man)
-endif()
-
-if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
-  if(NOT LLVM_ENABLE_EH)
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions")
-  endif()
-  if(NOT LLVM_ENABLE_RTTI)
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti")
-  endif()
-  if(CYGWIN OR MINGW)
-    # Use GNU extensions on Windows as LLVM upstream does.
-    set(std_cxx11 "-std=gnu++11")
-  else()
-    set(std_cxx11 "-std=c++11")
-  endif()
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${std_cxx11}")
 endif()
 
 macro(hint_clang_from_llvm)
@@ -82,6 +66,10 @@
 # Build scripts may set either LLVM_DIR or Clang_DIR.
 hint_llvm_from_clang()
 hint_clang_from_llvm()
+
+# If several LLVM versions provide CMake packages, try to use the latest one.
+set(CMAKE_FIND_PACKAGE_SORT_ORDER NATURAL)
+set(CMAKE_FIND_PACKAGE_SORT_DIRECTION DEC)
 
 # Clang 3.8+ installs its own CMake package.  Try it first.
 find_package(Clang QUIET)
@@ -123,6 +111,26 @@
     "that does not have `clang/` headers in any include directory:\n"
     "${tried_clang}"
     )
+endif()
+
+if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
+  if(NOT LLVM_ENABLE_EH)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions")
+  endif()
+  if(NOT LLVM_ENABLE_RTTI)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti")
+  endif()
+endif()
+if(CYGWIN OR MINGW)
+  # Use GNU extensions on Windows as LLVM upstream does.
+  set(CMAKE_CXX_EXTENSIONS ON)
+else()
+  set(CMAKE_CXX_EXTENSIONS OFF)
+endif()
+if(LLVM_VERSION_MAJOR GREATER 9)
+  set(CMAKE_CXX_STANDARD 14)
+else()
+  set(CMAKE_CXX_STANDARD 11)
 endif()
 
 add_definitions(${LLVM_DEFINITIONS})

=== debian/changelog ===
castxml (0.3.4-2) unstable; urgency=medium

  * Team upload
  * d/control: bump llvm requirements to version 10, to help address 957360
    affecting insighttoolkit4.

 -- Étienne Mollier <etienne.mollier@mailoo.org>  Tue, 04 Aug 2020 20:02:34 +0200

castxml (0.3.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)

 -- Andreas Tille <tille@debian.org>  Sun, 02 Aug 2020 19:30:30 +0200

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,17 @@
 Uploaders: Gert Wollny <gewo@debian.org>
 Section: devel
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper-compat (= 13),
                cmake,
                help2man,
-               libclang-9-dev,
-               llvm-9-dev,
+               libclang-10-dev,
+               llvm-10-dev,
                libedit-dev,
                zlib1g-dev
-Standards-Version: 4.1.5
+Standards-Version: 4.5.0
 Homepage: https://github.com/CastXML/CastXML
-Vcs-Browser:https://salsa.debian.org/med-team/castxml.git
+Rules-Requires-Root: no
+Vcs-Browser: https://salsa.debian.org/med-team/castxml
 Vcs-Git: https://salsa.debian.org/med-team/castxml.git
 
 Package: castxml

=== debian/rules ===
--- 
+++ 
@@ -2,10 +2,10 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
-# clang pulls in atomics that require an extra library on armel 
+# clang pulls in atomics that require an extra library on armel
 ifeq ($(DEB_HOST_ARCH),armel)
 export DEB_LDFLAGS_MAINT_APPEND=-latomic
-endif 
+endif
 
 
 CMAKE_FLAGS = -DCastXML_INSTALL_DOC_DIR:STRING=/usr/share/doc/castxml \
@@ -20,4 +20,3 @@
 override_dh_installman:
 	help2man -n "Create an XML representation of C++ declarations" --no-info debian/castxml/usr/bin/castxml  > castxml.1
 	dh_installman castxml.1
-

## castxml 0.3.6

=== debian/changelog ===
castxml (0.3.6-2ubuntu1) jammy; urgency=medium

  * Switch to LLVM/Clang 13
  * Tolerate GNU __attribute__((__malloc__)) with
    arguments for glibc 2.34

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 15 Feb 2022 13:59:00 +0000

castxml (0.3.6-2) unstable; urgency=medium

  * d/control: update to clang-11, Closes: #974782
  * d/control: cme fix dpkg

 -- Gert Wollny <gewo@debian.org>  Sat, 05 Dec 2020 23:37:22 +0100

castxml (0.3.6-1) unstable; urgency=medium

  * New upstream version 0.3.6

 -- Gert Wollny <gewo@debian.org>  Thu, 12 Nov 2020 12:51:55 +0100

=== debian/control ===
Source: castxml
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Steve M. Robbins <smr@debian.org>
Uploaders: Gert Wollny <gewo@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               help2man,
               libclang-13-dev,
               llvm-13-dev,
               libedit-dev,
               zlib1g-dev
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/med-team/castxml
Vcs-Git: https://salsa.debian.org/med-team/castxml.git
Homepage: https://github.com/CastXML/CastXML
Rules-Requires-Root: no

Package: castxml
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: C-family abstract syntax tree XML output tool
 Parse C-family source files and optionally write a subset of the
 Abstract Syntax Tree (AST) to a representation in XML.
 This is the successor to gccxml.

## castxml 0.4.4

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 # you may not use this file except in compliance with the License.
 # You may obtain a copy of the License at
 #
-#     http://www.apache.org/licenses/LICENSE-2.0
+#     https://www.apache.org/licenses/LICENSE-2.0
 #
 # Unless required by applicable law or agreed to in writing, software
 # distributed under the License is distributed on an "AS IS" BASIS,

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -67,6 +67,8 @@
     endif()
   endif()
 
+  set(_schema "${CastXML_SOURCE_DIR}/doc/manual/castxml.xsd")
+
   set(command $<TARGET_FILE:castxml>
     ${flag}
     ${_castxml_start}
@@ -82,6 +84,7 @@
     "-Dexpect=${_castxml_expect}"
     "-Dxml=${prefix}.${std}.${test}.xml"
     "-Dxmllint=${LIBXML2_XMLLINT_EXECUTABLE}"
+    "-Dschema=${_schema}"
     -P ${CMAKE_CURRENT_SOURCE_DIR}/run.cmake
     )
 endmacro()
@@ -329,4 +332,3 @@
 # Test predefined macros when not using --castxml-cc-<id>.
 configure_file(expect/cmd.predefined-macros.stdout.txt.in
                expect/cmd.predefined-macros.stdout.txt @ONLY)
-set(castxml_test_cmd_expect ${CMAKE_CURRENT_BINARY_DIR}/expect/cmd.predefined-macros)

=== debian/changelog ===
castxml (0.4.4-1) unstable; urgency=medium

  [ Gert Wollny ]
  * d/ci: delete created files

  [ Étienne Mollier ]
  * New upstream version 0.4.4.  (Closes: #1005805)
  * Standards-Version: 4.6.0 (routine-update)
  * watch file standard 4 (routine-update)
  * d/control: bump build dependency to llvm 13  (Closes: #1000931)
  * d/copyright: bump copyright years
  * d/copyright: remove reference to src/kwsys/* files
  * d/control: add myself to uploaders
  * d/control: set Debian Med as maintainer and move Steve to uploaders.
    Thanks Steve M. Robbins for the original packaging!

 -- Étienne Mollier <emollier@debian.org>  Tue, 15 Feb 2022 20:36:32 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: castxml
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Steve M. Robbins <smr@debian.org>
-Uploaders: Gert Wollny <gewo@debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Uploaders: Steve M. Robbins <smr@debian.org>,
+           Gert Wollny <gewo@debian.org>,
+           Étienne Mollier <emollier@debian.org>
 Section: devel
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
@@ -11,7 +12,7 @@
                llvm-13-dev,
                libedit-dev,
                zlib1g-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/castxml
 Vcs-Git: https://salsa.debian.org/med-team/castxml.git
 Homepage: https://github.com/CastXML/CastXML

=== debian/rules ===
--- 
+++ 
@@ -8,8 +8,7 @@
 endif
 
 
-CMAKE_FLAGS = -DCastXML_INSTALL_DOC_DIR:STRING=/usr/share/doc/castxml \
-              -DLLVM_DIR=/usr/lib/llvm-4.0/cmake
+CMAKE_FLAGS = -DCastXML_INSTALL_DOC_DIR:STRING=/usr/share/doc/castxml
 
 %:
 	dh $@

=== debian/watch ===
version=4

# Uncomment to find new files on Github
#  - when using releases:
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/castxml-$1\.tar\.gz/  \
https://github.com/CastXML/CastXML/releases .*/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## castxml 0.4.5

=== debian/changelog ===
castxml (0.4.5-1) unstable; urgency=medium

  * New upstream version

 -- Étienne Mollier <emollier@debian.org>  Tue, 05 Apr 2022 20:36:27 +0200

## castxml 0.4.6

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -328,7 +328,7 @@
 castxml_test_cmd(rsp-empty @${input}/empty.rsp)
 castxml_test_cmd(rsp-missing @${input}/does-not-exist.rsp)
 castxml_test_cmd(rsp-o-missing @${input}/o-missing.rsp)
+castxml_test_cmd(fbracket-depth -fbracket-depth=300 -std=c11 -c ${input}/fbracket-depth.c)
 
 # Test predefined macros when not using --castxml-cc-<id>.
 configure_file(expect/cmd.predefined-macros.stdout.txt.in
-               expect/cmd.predefined-macros.stdout.txt @ONLY)

=== debian/changelog ===
castxml (0.4.6-2) unstable; urgency=medium

  * d/watch: switch to git mode; fixes breakage of releases scan on Github.
  * d/control: append missing b-d following llvm packages reorganisation.

 -- Étienne Mollier <emollier@debian.org>  Wed, 12 Oct 2022 20:57:59 +0200

castxml (0.4.6-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)
  * d/control: bump build-depends to llvm toolchain 14. (Closes: #1017668)

 -- Étienne Mollier <emollier@debian.org>  Sun, 04 Sep 2022 14:26:58 +0200

=== debian/control ===
--- 
+++ 
@@ -8,11 +8,17 @@
 Build-Depends: debhelper-compat (= 13),
                cmake,
                help2man,
-               libclang-13-dev,
-               llvm-13-dev,
+               libclang-14-dev,
+               llvm-14-dev,
+               libmlir-14-dev,
+               mlir-14-tools,
+               clang-tools-14,
+               clang-format-14,
+               clang-tidy-14,
+               clangd-14,
                libedit-dev,
                zlib1g-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/castxml
 Vcs-Git: https://salsa.debian.org/med-team/castxml.git
 Homepage: https://github.com/CastXML/CastXML

## castxml 0.4.8

=== debian/changelog ===
castxml (0.4.8-1) unstable; urgency=medium

  [ Lance Lin ]
  * Team upload.
  * New upstream version

  [ Andreas Tille ]
  * Remove d/.gitlab-ci.yml

 -- Lance Lin <lqi254@protonmail.com>  Wed, 23 Nov 2022 21:39:59 +0700

## castxml 0.5.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -133,6 +133,11 @@
   set(CMAKE_CXX_STANDARD 11)
 endif()
 
+# Reserve ~10MB stack size on Windows, as LLVM upstream does.
+if(MSVC)
+  string(APPEND CMAKE_EXE_LINKER_FLAGS " -STACK:10000000")
+endif()
+
 add_definitions(${LLVM_DEFINITIONS})
 include_directories(${CLANG_INCLUDE_DIRS})
 include_directories(${LLVM_INCLUDE_DIRS})

=== debian/changelog ===
castxml (0.5.1-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)

 -- Étienne Mollier <emollier@debian.org>  Sat, 07 Jan 2023 17:52:35 +0100

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
                clangd-14,
                libedit-dev,
                zlib1g-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/castxml
 Vcs-Git: https://salsa.debian.org/med-team/castxml.git
 Homepage: https://github.com/CastXML/CastXML

## castxml 0.6.1

=== debian/changelog ===
castxml (0.6.1-1) unstable; urgency=medium

  [ Steve Robbins ]
  * Remove myself from uploaders.

  [ Étienne Mollier ]
  * New upstream version

 -- Étienne Mollier <emollier@debian.org>  Thu, 20 Jul 2023 10:25:47 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: castxml
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Steve M. Robbins <smr@debian.org>,
-           Gert Wollny <gewo@debian.org>,
+Uploaders: Gert Wollny <gewo@debian.org>,
            Étienne Mollier <emollier@debian.org>
 Section: devel
 Priority: optional
